/*
.text
#                    0x08    0x0C       0x10      0x14      0x18       0x1C      0x20      0x24       0x28  
#                     %0      %1         %2        %3        %4         %5        %6        %7         %8
.globl putline    #(int i1, int i2, int offset32, int y, int perm_y, int xsize, void* p2, void* p1)
.globl putlinedup #(int i1, int i2, int offset32, int y, int perm_y, int xsize, void* p2, void* p1, void* p2dup)
.globl putlinesw  #(void *src, void *dest, int size)
.extern colortable
*/
extern short colortable[1380 * 4];
static unsigned long putline_40D480[2] = { 0x00ff00ff, 0x00ff00ff };
static unsigned long putline_40D4C8[2] = { 0x80008000, 0x80008000 };
static unsigned char putline_40D4D0[8] =
  { 0xbf + 5, 0xf9 + 5, 0x89 + 5, 0x19 + 5, 0x49 + 5, 0x20 + 5,
  0x01 /*0xfe+5 */ , 0xf2 + 5
};
static unsigned long ands[2] = { 0x00f800f8, 0x00f800f8 };

inline void
putline (int i1, int i2, int offset32, int y, int perm_y, int xsize, void *p2,
         void *p1)
{
/*
putline: 
                "pushl %%ebp\n\t"
                "movl %%esp, %%ebp\n\t"
                "pushl %%edi\n\t"
                "pushl %%ebx\n\t"
*/
  __asm__ __volatile__ ("movl %4, %%eax\n\t"    // perm_y
                        "testl %%eax, %%eax\n\t"
                        "js  putline.m2\n\t"
                        "cmpl $0x00000020, %%eax\n\t" "jae putline.m1\n\t" "subl %2, %%eax\n\t"    // offset32
                        "putline.m1:\n\t" "subl %3, %%eax\n\t"    // y
                        "leal 0x4E0(,%%eax,4), %%edi\n\t" "movl %0, %%eax\n\t"    // i1
                        "movl %2, %%ebx\n\t"    // i2
                        "andl $00000001, %%eax\n\t"
                        "andl $00000001, %%ebx\n\t"
                        "leal (%%ebx,%%eax,2), %%eax\n\t"
                        "addl %%eax, %%edi\n\t" "leal colortable(,%%edi,8), %%edi\n\t"    // colortable
                        "putline.m2:\n\t" "movl %7, %%edx\n\t"    // p1
                        "movl %5, %%ecx\n\t"    // xsize
                        "movq (%%edi), %%mm7\n\t" "movq putline_40D480, %%mm4\n\t"    // putline_40D480
                        "shrl $3, %%ecx\n\t" "movl %6, %%ebx\n\t"    // p2
                        "movq (%%edx), %%mm0\n\t"
                        "addl $8, %%edx\n\t"
                        "subl $8, %%ebx\n\t"
                        "jmp putline.m4\n\t"
                        ".align 16\n\t"
                        "putline.m3:\n\t"
                        "movq (%%edx), %%mm0\n\t"
                        "addl $8, %%edx\n\t"
                        "movq %%mm2, (%%ebx)\n\t" "putline.m4:\n\t" "movq %%mm0, %%mm2\n\t" "psubb putline_40D4C8, %%mm0\n\t"    // putline_40D4C8
                        "addl $8, %%ebx\n\t"    // 0x00000010
                        "psraw $8, %%mm0\n\t"
                        "pand %%mm4, %%mm2\n\t"
                        "movq %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw $1, %%mm2\n\t"
                        "pmaddwd %%mm7, %%mm0\n\t"
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq %%mm2, %%mm5\n\t"
                        "pmaddwd %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad $0x0B, %%mm0\n\t"
                        "psrad $0x0B, %%mm1\n\t"
                        "packssdw %%mm1, %%mm0\n\t"
                        "packssdw %%mm1, %%mm1\n\t"
                        "paddsw %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t" "movq %%mm0, %%mm6\n\t" "movq putline_40D4D0, %%mm3\n\t"    // putline_40D4D0
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw %%mm3, %%mm0\n\t"
                        "movq %%mm2, %%mm1\n\t"
                        "psllq $8, %%mm2\n\t"
                        "movq %%mm6, %%mm3\n\t"
                        "psrlq $0x30, %%mm6\n\t"
                        "por %%mm1, %%mm2\n\t"
                        "paddsw %%mm3, %%mm6\n\t"
                        "movq %%mm5, %%mm3\n\t"
                        "psllq $8, %%mm5\n\t"
                        "packsswb %%mm6, %%mm6\n\t"
                        "movq %%mm0, %%mm1\n\t"
                        "psrlq $0x30, %%mm0\n\t"
                        "por %%mm3, %%mm5\n\t"
                        "paddsw %%mm1, %%mm0\n\t"
                        "pxor %%mm1, %%mm1\n\t"
                        "packsswb %%mm0, %%mm0\n\t"
                        "pxor %%mm3, %%mm3\n\t"
                        "paddsb %%mm0, %%mm5\n\t"
                        "paddsb %%mm6, %%mm2\n\t"
                        "pcmpgtb %%mm5, %%mm3\n\t"
                        "pandn %%mm5, %%mm3\n\t"
                        "pcmpgtb %%mm2, %%mm1\n\t"
                        "movq %%mm3, %%mm0\n\t"
                        "pand %%mm4, %%mm3\n\t"
                        "psrld $0x0A, %%mm0\n\t" "pandn %%mm2, %%mm1\n\t" "pslld $0x1B, %%mm0\n\t"    // 0x1A
                        "movq %%mm3, %%mm5\n\t"
                        "psrlw $2, %%mm3\n\t" "movq %%mm1, %%mm2\n\t" "psrld $1, %%mm5\n\t"    // 02
                        "pand %%mm4, %%mm1\n\t"
                        "pslld $0x15, %%mm5\n\t"
                        "por %%mm0, %%mm5\n\t"
                        "movq %%mm1, %%mm0\n\t"
                        "psrlw $2, %%mm1\n\t" "por %%mm3, %%mm5\n\t" "psrld $1, %%mm0\n\t"    // 02
                        "pslld $0x15, %%mm0\n\t"
                        "psrad $0x10, %%mm5\n\t"
                        "por %%mm0, %%mm1\n\t" "psrld $0x0A, %%mm2\n\t" "pslld $0x1B, %%mm2\n\t"    // 0x1A
                        "por %%mm1, %%mm2\n\t"
                        "psrad $0x10, %%mm2\n\t"
                        "decl %%ecx\n\t"
                        "packssdw %%mm5, %%mm2\n\t"
                        "jne putline.m3\n\t"
                        "movq %%mm2, (%%ebx)\n\t" "emms\n\t":    /* no output */
                        :        /* input */
                        "g" (i1),    /* %0 */
                        "g" (i2),    /* %1 */
                        "g" (offset32),    /* %2 */
                        "g" (y),    /* %3 */
                        "g" (perm_y),    /* %4 */
                        "g" (xsize),    /* %5 */
                        "g" (p2),    /* %6 */
                        "g" (p1)    /* %7 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"    /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        /*
                           "popl %%ebx\n\t"
                           "popl %%edi\n\t"
                           "popl %%ebp\n\t"
                           ret
                         */
    );


}


inline void
putlinedup (int i1, int i2, int offset32, int y, int perm_y, int xsize,
            void *p2, void *p1, void *p2dup)
{
/*
putlinedup: 
                "pushl %%ebp\n\t"
                "movl %%esp, %%ebp\n\t"
                "pushl %%edi\n\t"
                "pushl %%ebx\n\t"
*/
  __asm__ __volatile__ ("movl %4, %%eax\n\t"    // perm_y
                        "testl %%eax, %%eax\n\t"
                        "js  putlinedup.m2\n\t"
                        "cmpl $0x00000020, %%eax\n\t" "jae putlinedup.m1\n\t" "subl %2, %%eax\n\t"    // offset32
                        "putlinedup.m1:\n\t" "subl %3, %%eax\n\t"    // y
                        "leal 0x4E0(,%%eax,4), %%edi\n\t" "movl %0, %%eax\n\t"    // i1
                        "movl %1, %%ebx\n\t"    // i2
                        "andl $00000001, %%eax\n\t"
                        "andl $00000001, %%ebx\n\t"
                        "leal (%%ebx,%%eax,2), %%eax\n\t"
                        "addl %%eax, %%edi\n\t" "leal colortable(,%%edi,8), %%edi\n\t"    // colortable
                        "putlinedup.m2:\n\t" "movl %7, %%edx\n\t"    // p1
                        "movl %5, %%ecx\n\t"    // xsize
                        "movq (%%edi), %%mm7\n\t" "movq putline_40D480, %%mm4\n\t"    // putlinedup_40D480
                        "shrl $3, %%ecx\n\t" "movl %6, %%ebx\n\t"    // p2
                        "movl %8, %%eax\n\t"    // p2dup
                        "movq (%%edx), %%mm0\n\t"
                        "addl $8, %%edx\n\t"
                        "subl $8, %%ebx\n\t"
                        "subl $8, %%eax\n\t"
                        "jmp putlinedup.m4\n\t"
                        ".align 16\n\t"
                        "putlinedup.m3:\n\t"
                        "movq (%%edx), %%mm0\n\t"
                        "addl $8, %%edx\n\t"
                        "movq %%mm2, (%%ebx)\n\t"
                        "movq %%mm2, (%%eax)\n\t"
                        "putlinedup.m4:\n\t" "movq %%mm0, %%mm2\n\t" "psubb putline_40D4C8, %%mm0\n\t"    // putlinedup_40D4C8
                        "addl $8, %%ebx\n\t"
                        "addl $8, %%eax\n\t"
                        "psraw $8, %%mm0\n\t"
                        "pand %%mm4, %%mm2\n\t"
                        "movq %%mm0, %%mm1\n\t"
                        "punpckldq %%mm0, %%mm0\n\t"
                        "psrlw $1, %%mm2\n\t"
                        "pmaddwd %%mm7, %%mm0\n\t"
                        "punpckhdq %%mm1, %%mm1\n\t"
                        "movq %%mm2, %%mm5\n\t"
                        "pmaddwd %%mm7, %%mm1\n\t"
                        "punpcklbw %%mm2, %%mm2\n\t"
                        "psrad $0x0B, %%mm0\n\t"
                        "psrad $0x0B, %%mm1\n\t"
                        "packssdw %%mm1, %%mm0\n\t"
                        "packssdw %%mm1, %%mm1\n\t"
                        "paddsw %%mm0, %%mm0\n\t"
                        "punpckhbw %%mm5, %%mm5\n\t" "movq %%mm0, %%mm6\n\t" "movq putline_40D4D0, %%mm3\n\t"    // putlinedup_40D4D0
                        "punpckldq %%mm6, %%mm6\n\t"
                        "pmulhw %%mm3, %%mm6\n\t"
                        "punpckhdq %%mm0, %%mm0\n\t"
                        "pmulhw %%mm3, %%mm0\n\t"
                        "movq %%mm2, %%mm1\n\t"
                        "psllq $8, %%mm2\n\t"
                        "movq %%mm6, %%mm3\n\t"
                        "psrlq $0x30, %%mm6\n\t"
                        "por %%mm1, %%mm2\n\t"
                        "paddsw %%mm3, %%mm6\n\t"
                        "movq %%mm5, %%mm3\n\t"
                        "psllq $8, %%mm5\n\t"
                        "packsswb %%mm6, %%mm6\n\t"
                        "movq %%mm0, %%mm1\n\t"
                        "psrlq $0x30, %%mm0\n\t"
                        "por %%mm3, %%mm5\n\t"
                        "paddsw %%mm1, %%mm0\n\t"
                        "pxor %%mm1, %%mm1\n\t"
                        "packsswb %%mm0, %%mm0\n\t"
                        "pxor %%mm3, %%mm3\n\t"
                        "paddsb %%mm0, %%mm5\n\t"
                        "paddsb %%mm6, %%mm2\n\t"
                        "pcmpgtb %%mm5, %%mm3\n\t"
                        "pandn %%mm5, %%mm3\n\t"
                        "pcmpgtb %%mm2, %%mm1\n\t"
                        "movq %%mm3, %%mm0\n\t"
                        "pand %%mm4, %%mm3\n\t"
                        "psrld $0x0A, %%mm0\n\t" "pandn %%mm2, %%mm1\n\t" "pslld $0x1B, %%mm0\n\t"    // 0x1A
                        "movq %%mm3, %%mm5\n\t"
                        "psrlw $2, %%mm3\n\t" "movq %%mm1, %%mm2\n\t" "psrld $1, %%mm5\n\t"    // 02
                        "pand %%mm4, %%mm1\n\t"
                        "pslld $0x15, %%mm5\n\t"
                        "por %%mm0, %%mm5\n\t"
                        "movq %%mm1, %%mm0\n\t"
                        "psrlw $2, %%mm1\n\t" "por %%mm3, %%mm5\n\t" "psrld $1, %%mm0\n\t"    // 02
                        "pslld $0x15, %%mm0\n\t"
                        "psrad $0x10, %%mm5\n\t"
                        "por %%mm0, %%mm1\n\t" "psrld $0x0A, %%mm2\n\t" "pslld $0x1B, %%mm2\n\t"    // 0x1A
                        "por %%mm1, %%mm2\n\t"
                        "psrad $0x10, %%mm2\n\t"
                        "decl %%ecx\n\t"
                        "packssdw %%mm5, %%mm2\n\t"
                        "jne putlinedup.m3\n\t"
                        "movq %%mm2, (%%ebx)\n\t"
                        "movq %%mm2, (%%eax)\n\t" "emms\n\t":    /* no output */
                        :        /* input */
                        "g" (i1),    /* %0 */
                        "g" (i2),    /* %1 */
                        "g" (offset32),    /* %2 */
                        "g" (y),    /* %3 */
                        "g" (perm_y),    /* %4 */
                        "g" (xsize),    /* %5 */
                        "g" (p2),    /* %6 */
                        "g" (p1),    /* %7 */
                        "g" (p2dup)    /* %8 */
                        :        /* modified regs */
                        "eax", "ebx", "ecx", "edx", "edi"    /*, "mm0", "mm1", "mm2", "mm3", "mm4", "mm5", "mm6", "mm7" */
                        /*
                           "popl %%ebx\n\t"
                           "popl %%edi\n\t"
                           "popl %%ebp\n\t"
                           ret
                         */
    );
}

inline void
putlinesw (void *src, void *dest, int size)
{
/*
putlinesw: 
        "pushl %%ebp\n\t"
        "movl %%esp, %%ebp\n\t"
        "subw $0x40, %%sp\n\t"
        "pushl %%ebx\n\t"
        "pushl %%esi\n\t"
        "pushl %%ecx\n\t"
*/

  __asm__ __volatile__ ("movl %0, %%ebx\n\t"    // src
                        "movl %1, %%esi\n\t"    // dest
                        "movl %2, %%ecx\n\t"    // size 
                        "shrl $2, %%ecx\n\t" "movq ands, %%mm6\n\t"    // ands
                        ".align 16\n\t"
                        "putlinesw.contsw:\n\t"
                        "movq (%%ebx), %%mm1\n\t"
                        "pand  %%mm6, %%mm1\n\t"
                        "psrlw $3, %%mm1\n\t"
                        "movq %%mm1, %%mm2\n\t"
                        "psllw $6, %%mm2\n\t"
                        "movq %%mm1, %%mm3\n\t"
                        "psllw $11, %%mm3\n\t"
                        "por %%mm2, %%mm1\n\t"
                        "por %%mm3, %%mm1\n\t"
                        "movq %%mm1, (%%esi)\n\t"
                        "addl $8, %%esi\n\t"
                        "addl $8, %%ebx\n\t"
                        "decl %%ecx\n\t" "jnz putlinesw.contsw\n\t" "emms\n\t":    /* no output */
                        : /* input */ "g" (src), "g" (dest), "g" (size)    /*, "m" (ands) */
                        :"ebx", "ecx", "edx", "esi"    /*, "mm1", "mm2", "mm3", "mm6" */
                        /*
                           "popl %%ecx\n\t"
                           "popl %%esi\n\t"
                           "popl %%ebx\n\t"
                           "leave\n\t"
                           ret
                         */
    );


}
