#ifndef _FILTRE_H_
#define  _FILTRE_H_

#ifndef DISABLE_ALL_FILTERS
# if (!defined(ENABLE_KIZKOOL25)) && (!defined(ENABLE_KIZKOOL28)) && (!defined(ENABLE_KIZKOOL30)) && (!defined(ENABLE_KIZKOOL31)) && (!defined(ENABLE_KIZKOOL32)) && (!defined(ENABLE_SNABRAB)) && (!defined(ENABLE_FASOUIL))
#  define DISABLE_ALL_FILTERS 1
# endif
#endif

#if (!defined(ENABLE_KIZKOOL25)) && (!defined(ENABLE_KIZKOOL28)) && (!defined(ENABLE_KIZKOOL30)) && (!defined(ENABLE_KIZKOOL31)) && (!defined(ENABLE_KIZKOOL32)) && (!defined(ENABLE_SNABRAB))
# define DISABLE_ALL_KIZKOOL 1
#endif



/*
#define BLUEFILTER_OFF 0

// KizKoool like filters
#define BLUEFILTER_K25 1
#define BLUEFILTER_K28 2
#define BLUEFILTER_K30 3
#define BLUEFILTER_K31 4
#define BLUEFILTER_K32 5
#define BLUEFILTER_K32SNABRAB 6
// Fasouil like filters
#define BLUEFILTER_FAS 7

#define NB_KIZKOOL_FILTER 6
#define NB_BLUEFILTER  8
*/

#ifndef DISABLE_ALL_FILTERS
enum {
    BLUEFILTER_OFF=0,
#ifdef ENABLE_KIZKOOL25
    BLUEFILTER_K25,
#endif
#ifdef ENABLE_KIZKOOL28
    BLUEFILTER_K28,
#endif
#ifdef ENABLE_KIZKOOL30
    BLUEFILTER_K30,
#endif
#ifdef ENABLE_KIZKOOL31
    BLUEFILTER_K31,
#endif
#ifdef ENABLE_KIZKOOL32
    BLUEFILTER_K32,
#endif
#ifdef ENABLE_SNABRAB
    BLUEFILTER_K32SNABRAB,
#endif
#ifdef ENABLE_FASOUIL
    BLUEFILTER_FAS,
#endif
    LAST_BLUEFILTER_ELT
};

#define NB_BLUEFILTER     (LAST_BLUEFILTER_ELT)

#ifdef ENABLE_FASOUIL
# define NB_KIZKOOL_FILTER (NB_BLUEFILTER - 2)
#else
# define NB_KIZKOOL_FILTER (NB_BLUEFILTER - 1)
#endif

#define SMUDGEFILTER_OFF 0
#define SMUDGEFILTER_ON  1

void init_filter (void);

#endif // DISABLE_ALL_FILTERS

#endif // _FILTRE_H_
