#ifndef vcrypt_h_
#define vcrypt_h_

#define SKIP 10
#ifndef PI
#define PI 3.141592654
#endif

extern int h_offset[288];
extern unsigned short yuvtab[64 * 64 * 64][4];
extern int color_index_left[288], color_index_right[288];
extern int scryptphase;
extern int known_vc_keys;
extern short *vc_keys;

void rotateFirstHalfLine (unsigned char *line, int shift, int xWidth,
              int skip);

void autoDetectEdges2 (unsigned char *baseline, unsigned char *line,
               int xWidth, int skip,
               int blnr, int lnr, int bloff, int loff, int *offsets,
               unsigned long int *ldiffs);

void vc_bild_ausrichtung (unsigned char *buffer, int xWidth, int skip,
              int line, int shift);

int findShift (unsigned char *baseline, unsigned char *line, int xWidth,
           int skip);
unsigned long int line_diff2 (unsigned char *bline, unsigned char *line,
                  int width, unsigned long int limit);

unsigned long int line_diff4 (unsigned char *bline, unsigned char *line,
                  int width,
                  int blnr, int bloff, int lnr, int loff,
                  int bl_left_length, int l_left_length);
unsigned long int line_diff3 (unsigned char *bline, unsigned char *line,
                  int width);



int findExtraShift2 (unsigned char *baseline, unsigned char *line,
             int xWidth, int skip, int blnr, int lnr);

void make_yuyv (unsigned char *p1, int *y1, int *u, int *y2, int *v,
        int cp, int line_nr, int wo);


void decodeFrameVC3 (unsigned char *buffer, int xBufferWidth,
             int yBorderHeight, int color);
int decodeFrameVCKey (unsigned char *buffer);
int find_vc_key (unsigned char *buffer, int xWidth, int skip);

int load_vc_keys (char *keyfile);

int decoded_vcrypt (unsigned char *buffer);

#endif
