.text

.global try_perm_asm # short *try_perm_asm(void)

.extern key_lines
.extern number_couples
.extern correl_lines
.extern status_line
.extern table_keys

.macro correl p1
        movl $0x0000ffff,%edx   # mask
        movl $key_lines, %edi
        movl $correl_lines, %esi
        movl $0x7fffffff,%eax
        movl %eax,corr_min
        movl $0,%eax
        movl %eax,key_min

nextkey_\@:
        xorl %ecx,%ecx          # corr

.set i, 0
.rept \p1/2
        movl i*4(%edi),%eax
        movl %eax,%ebx
        shrl $16,%eax
        andl %edx,%ebx
        addl (%esi,%eax),%ecx
        addl (%esi,%ebx),%ecx
.if i==\p1/4+1
        cmpl %ecx,corr_min
        jle  badkey_\@
.endif
.set i, i+1
.endr

        cmpl %ecx,corr_min
        jle  badkey_\@

        movl %ecx,corr_min
        movl %edi,key_min

badkey_\@:

    addl $\p1*2, %edi                # key_ptr+=NB_COUPLES 
        cmpl $key_lines+32768*\p1*2, %edi
        jnz  nextkey_\@
        jmp  ende
.endm


try_perm_asm: 
        pushl %ebp
        movl  %esp,%ebp
        subw  $0x40,%sp
        pushl %ebx
        pushl %ecx
        pushl %edx
        pushl %esi
        pushl %edi

        movl    number_couples,%eax
        andl    $0xfffffffc,%eax
        addl    $fkttab, %eax
        movl    (%eax),%ebx
        jmp     *%ebx

try4:   
        correl 4
try8:   
        correl 8
try12:  
        correl 12
try16:  
        correl 16
try20:  
        correl 20
try24: 
        correl 24
try28:   
        correl 28
try32:  
        correl 32
try36:  
        correl 36
try40:  
        correl 40
try44:  
        correl 44
try48:  
        correl 48
try52:  
        correl 52
try56:  
        correl 56
try60:  
        correl 60
try64:  
        correl 64
try68:  
        correl 68
try72:  
        correl 72
try76:  
        correl 76
try80:  
        correl 80
try84:  
        correl 84
try88:  
        correl 88

ende:   movl key_min,%eax

        popl %edi
        popl %esi
        popl %edx
        popl %ecx
        popl %ebx
        leave
        ret

.data
key_min:        .long      0x00000000
corr_min:       .long      0x00000000
fkttab:         .long      0
                .long      try4
                .long      try8
                .long      try12
                .long      try16
                .long      try20
                .long      try24
                .long      try28
                .long      try32
                .long      try36
                .long      try40
                .long      try44
                .long      try48
                .long      try52
                .long      try56
                .long      try60
                .long      try64
                .long      try68
                .long      try72
                .long      try76
                .long      try80
                .long      try84
                .long      try88

